import { Toml } from '../../types';

export function generateWorkspaceCargoToml(rootPath: string): Toml {
    return `
        # This code is automatically generated by Azle

        [workspace]
        members = [
            "${rootPath}",
            "${rootPath}/azle_generate"
        ]

        [profile.release]
        opt-level = 'z'

        [profile.test]
        opt-level = 'z'
    `;
}

export function generateLibCargoToml(canisterName: string): Toml {
    return `
        # This code is automatically generated by Azle

        [package]
        name = "${canisterName}"
        version = "0.0.0"
        edition = "2018"

        [lib]
        crate-type = ["cdylib"]

        [dependencies]
        ic-cdk = { version = "0.6.8", features = ["timers"] }
        ic-cdk-macros = "0.6.8"
        candid = "0.8.4"
        boa_engine = { git = "https://github.com/demergent-labs/boa", rev = "9ef62f77d8f0ce01053452c55b5a51e2a912e60d" }
        # boa_engine = { path = "../../../../../../boa/boa_engine" }
        getrandom = { version = "0.2.3", features = ["custom"] }
        serde = "1.0.137"
        azle-vm-value-derive = { path = "./azle_vm_value_derive" }
        uuid = { version = "1.2.2", features = ["v4"] }
        rand = "0.8.5"
        slotmap = "1.0.6"
    `;
}

export function generateWorkspaceCargoLock(): Toml {
    return `
        # This file is automatically @generated by Cargo.
        # It is not intended for manual editing.
        version = 3

        [[package]]
        name = "Inflector"
        version = "0.11.4"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "fe438c63458706e03479442743baae6c88256498e6431708f6dfc520a26515d3"
        dependencies = [
        "lazy_static",
        "regex",
        ]

        [[package]]
        name = "ahash"
        version = "0.7.6"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "fcb51a0695d8f838b1ee009b3fbf66bda078cd64590202a864a8f3e8c4315c47"
        dependencies = [
        "getrandom",
        "once_cell",
        "version_check",
        ]

        [[package]]
        name = "aho-corasick"
        version = "0.7.20"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "cc936419f96fa211c1b9166887b38e5e40b19958e5b895be7c1f93adec7071ac"
        dependencies = [
        "memchr",
        ]

        [[package]]
        name = "android_system_properties"
        version = "0.1.5"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "819e7219dbd41043ac279b19830f2efc897156490d7fd6ea916720117ee66311"
        dependencies = [
        "libc",
        ]

        [[package]]
        name = "annotate-snippets"
        version = "0.9.1"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "c3b9d411ecbaf79885c6df4d75fff75858d5995ff25385657a28af47e82f9c36"
        dependencies = [
        "unicode-width",
        ]

        [[package]]
        name = "anyhow"
        version = "1.0.68"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "2cb2f989d18dd141ab8ae82f64d1a8cdd37e0840f73a406896cf5e99502fab61"

        [[package]]
        name = "arrayvec"
        version = "0.5.2"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "23b62fc65de8e4e7f52534fb52b0f3ed04746ae267519eef2a83941e8085068b"

        [[package]]
        name = "ascii-canvas"
        version = "3.0.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "8824ecca2e851cec16968d54a01dd372ef8f95b244fb84b84e70128be347c3c6"
        dependencies = [
        "term",
        ]

        [[package]]
        name = "ast_node"
        version = "0.8.6"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "cf94863c5fdfee166d0907c44e5fee970123b2b7307046d35d1e671aa93afbba"
        dependencies = [
        "darling",
        "pmutil",
        "proc-macro2",
        "quote",
        "swc_macros_common",
        "syn",
        ]

        [[package]]
        name = "atty"
        version = "0.2.14"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "d9b39be18770d11421cdb1b9947a45dd3f37e93092cbf377614828a319d5fee8"
        dependencies = [
        "hermit-abi",
        "libc",
        "winapi",
        ]

        [[package]]
        name = "autocfg"
        version = "1.1.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "d468802bab17cbc0cc575e9b053f41e72aa36bfa6b7f55e3529ffa43161b97fa"

        [[package]]
        name = "azle-vm-value-derive"
        version = "0.0.0"
        dependencies = [
        "proc-macro2",
        "quote",
        "syn",
        ]

        [[package]]
        name = "azle_generate"
        version = "0.0.0"
        dependencies = [
        "annotate-snippets",
        "cdk_framework",
        "derive-syn-parse",
        "proc-macro2",
        "quote",
        "swc_common",
        "swc_ecma_ast",
        "swc_ecma_parser",
        "syn",
        ]

        [[package]]
        name = "beef"
        version = "0.5.2"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "3a8241f3ebb85c056b509d4327ad0358fbbba6ffb340bf388f26350aeda225b1"

        [[package]]
        name = "better_scoped_tls"
        version = "0.1.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "b73e8ecdec39e98aa3b19e8cd0b8ed8f77ccb86a6b0b2dc7cd86d105438a2123"
        dependencies = [
        "scoped-tls",
        ]

        [[package]]
        name = "binread"
        version = "2.2.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "16598dfc8e6578e9b597d9910ba2e73618385dc9f4b1d43dd92c349d6be6418f"
        dependencies = [
        "binread_derive",
        "lazy_static",
        "rustversion",
        ]

        [[package]]
        name = "binread_derive"
        version = "2.1.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "1d9672209df1714ee804b1f4d4f68c8eb2a90b1f7a07acf472f88ce198ef1fed"
        dependencies = [
        "either",
        "proc-macro2",
        "quote",
        "syn",
        ]

        [[package]]
        name = "bit-set"
        version = "0.5.3"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "0700ddab506f33b20a03b13996eccd309a48e5ff77d0d95926aa0210fb4e95f1"
        dependencies = [
        "bit-vec",
        ]

        [[package]]
        name = "bit-vec"
        version = "0.6.3"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "349f9b6a179ed607305526ca489b34ad0a41aed5f7980fa90eb03160b69598fb"

        [[package]]
        name = "bitflags"
        version = "1.3.2"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "bef38d45163c2f1dde094a7dfd33ccf595c92905c8f8f4fdc18d06fb1037718a"

        [[package]]
        name = "block-buffer"
        version = "0.10.3"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "69cce20737498f97b993470a6e536b8523f0af7892a4f928cceb1ac5e52ebe7e"
        dependencies = [
        "generic-array",
        ]

        [[package]]
        name = "boa_ast"
        version = "0.16.0"
        source = "git+https://github.com/demergent-labs/boa?rev=9ef62f77d8f0ce01053452c55b5a51e2a912e60d#9ef62f77d8f0ce01053452c55b5a51e2a912e60d"
        dependencies = [
        "bitflags",
        "boa_interner",
        "boa_macros",
        "num-bigint",
        "rustc-hash",
        ]

        [[package]]
        name = "boa_engine"
        version = "0.16.0"
        source = "git+https://github.com/demergent-labs/boa?rev=9ef62f77d8f0ce01053452c55b5a51e2a912e60d#9ef62f77d8f0ce01053452c55b5a51e2a912e60d"
        dependencies = [
        "bitflags",
        "boa_ast",
        "boa_gc",
        "boa_interner",
        "boa_macros",
        "boa_parser",
        "boa_profiler",
        "chrono",
        "dyn-clone",
        "fast-float",
        "ic-cdk",
        "indexmap",
        "num-bigint",
        "num-integer",
        "num-traits",
        "once_cell",
        "rand",
        "regress",
        "rustc-hash",
        "ryu-js",
        "serde",
        "serde_json",
        "sptr",
        "static_assertions",
        "tap",
        "thiserror",
        "unicode-normalization",
        ]

        [[package]]
        name = "boa_gc"
        version = "0.16.0"
        source = "git+https://github.com/demergent-labs/boa?rev=9ef62f77d8f0ce01053452c55b5a51e2a912e60d#9ef62f77d8f0ce01053452c55b5a51e2a912e60d"
        dependencies = [
        "boa_macros",
        "boa_profiler",
        ]

        [[package]]
        name = "boa_interner"
        version = "0.16.0"
        source = "git+https://github.com/demergent-labs/boa?rev=9ef62f77d8f0ce01053452c55b5a51e2a912e60d#9ef62f77d8f0ce01053452c55b5a51e2a912e60d"
        dependencies = [
        "boa_macros",
        "indexmap",
        "once_cell",
        "phf",
        "rustc-hash",
        "static_assertions",
        ]

        [[package]]
        name = "boa_macros"
        version = "0.16.0"
        source = "git+https://github.com/demergent-labs/boa?rev=9ef62f77d8f0ce01053452c55b5a51e2a912e60d#9ef62f77d8f0ce01053452c55b5a51e2a912e60d"
        dependencies = [
        "proc-macro2",
        "quote",
        "syn",
        "synstructure",
        ]

        [[package]]
        name = "boa_parser"
        version = "0.16.0"
        source = "git+https://github.com/demergent-labs/boa?rev=9ef62f77d8f0ce01053452c55b5a51e2a912e60d#9ef62f77d8f0ce01053452c55b5a51e2a912e60d"
        dependencies = [
        "bitflags",
        "boa_ast",
        "boa_interner",
        "boa_macros",
        "boa_profiler",
        "boa_unicode",
        "fast-float",
        "num-bigint",
        "num-traits",
        "rustc-hash",
        ]

        [[package]]
        name = "boa_profiler"
        version = "0.16.0"
        source = "git+https://github.com/demergent-labs/boa?rev=9ef62f77d8f0ce01053452c55b5a51e2a912e60d#9ef62f77d8f0ce01053452c55b5a51e2a912e60d"

        [[package]]
        name = "boa_unicode"
        version = "0.16.0"
        source = "git+https://github.com/demergent-labs/boa?rev=9ef62f77d8f0ce01053452c55b5a51e2a912e60d#9ef62f77d8f0ce01053452c55b5a51e2a912e60d"
        dependencies = [
        "unicode-general-category",
        ]

        [[package]]
        name = "bumpalo"
        version = "3.11.1"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "572f695136211188308f16ad2ca5c851a712c464060ae6974944458eb83880ba"

        [[package]]
        name = "byteorder"
        version = "1.4.3"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "14c189c53d098945499cdfa7ecc63567cf3886b3332b312a5b4585d8d3a6a610"

        [[package]]
        name = "call_raw"
        version = "0.0.0"
        dependencies = [
        "azle-vm-value-derive",
        "boa_engine",
        "candid",
        "getrandom",
        "ic-cdk",
        "ic-cdk-macros",
        "rand",
        "serde",
        "slotmap",
        "uuid",
        ]

        [[package]]
        name = "candid"
        version = "0.8.4"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "244005a1917bb7614cd775ca8a5d59efeb5ac74397bb14ba29a19347ebd78591"
        dependencies = [
        "anyhow",
        "binread",
        "byteorder",
        "candid_derive",
        "codespan-reporting",
        "crc32fast",
        "data-encoding",
        "hex",
        "lalrpop",
        "lalrpop-util",
        "leb128",
        "logos",
        "num-bigint",
        "num-traits",
        "num_enum",
        "paste",
        "pretty",
        "serde",
        "serde_bytes",
        "sha2",
        "thiserror",
        ]

        [[package]]
        name = "candid_derive"
        version = "0.5.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "58f1f4db7c7d04b87b70b3a35c5dc5c2c9dd73cef8bdf6760e2f18a0d45350dd"
        dependencies = [
        "lazy_static",
        "proc-macro2",
        "quote",
        "syn",
        ]

        [[package]]
        name = "cc"
        version = "1.0.78"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "a20104e2335ce8a659d6dd92a51a767a0c062599c73b343fd152cb401e828c3d"

        [[package]]
        name = "cdk_framework"
        version = "0.0.0"
        source = "git+https://github.com/demergent-labs/cdk_framework?rev=4eb94999c137dc35142898206ab12415832f2381#4eb94999c137dc35142898206ab12415832f2381"
        dependencies = [
        "proc-macro2",
        "quote",
        "regex",
        ]

        [[package]]
        name = "cfg-if"
        version = "1.0.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "baf1de4339761588bc0619e3cbc0120ee582ebb74b53b4efbf79117bd2da40fd"

        [[package]]
        name = "chrono"
        version = "0.4.23"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "16b0a3d9ed01224b22057780a37bb8c5dbfe1be8ba48678e7bf57ec4b385411f"
        dependencies = [
        "iana-time-zone",
        "num-integer",
        "num-traits",
        "winapi",
        ]

        [[package]]
        name = "codespan-reporting"
        version = "0.11.1"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "3538270d33cc669650c4b093848450d380def10c331d38c768e34cac80576e6e"
        dependencies = [
        "termcolor",
        "unicode-width",
        ]

        [[package]]
        name = "core-foundation-sys"
        version = "0.8.3"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "5827cebf4670468b8772dd191856768aedcb1b0278a04f989f7766351917b9dc"

        [[package]]
        name = "cpufeatures"
        version = "0.2.5"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "28d997bd5e24a5928dd43e46dc529867e207907fe0b239c3477d924f7f2ca320"
        dependencies = [
        "libc",
        ]

        [[package]]
        name = "crc32fast"
        version = "1.3.2"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "b540bd8bc810d3885c6ea91e2018302f68baba2129ab3e88f32389ee9370880d"
        dependencies = [
        "cfg-if",
        ]

        [[package]]
        name = "crunchy"
        version = "0.2.2"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "7a81dae078cea95a014a339291cec439d2f232ebe854a9d672b796c6afafa9b7"

        [[package]]
        name = "crypto-common"
        version = "0.1.6"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "1bfb12502f3fc46cca1bb51ac28df9d618d813cdc3d2f25b9fe775a34af26bb3"
        dependencies = [
        "generic-array",
        "typenum",
        ]

        [[package]]
        name = "cxx"
        version = "1.0.85"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "5add3fc1717409d029b20c5b6903fc0c0b02fa6741d820054f4a2efa5e5816fd"
        dependencies = [
        "cc",
        "cxxbridge-flags",
        "cxxbridge-macro",
        "link-cplusplus",
        ]

        [[package]]
        name = "cxx-build"
        version = "1.0.85"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "b4c87959ba14bc6fbc61df77c3fcfe180fc32b93538c4f1031dd802ccb5f2ff0"
        dependencies = [
        "cc",
        "codespan-reporting",
        "once_cell",
        "proc-macro2",
        "quote",
        "scratch",
        "syn",
        ]

        [[package]]
        name = "cxxbridge-flags"
        version = "1.0.85"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "69a3e162fde4e594ed2b07d0f83c6c67b745e7f28ce58c6df5e6b6bef99dfb59"

        [[package]]
        name = "cxxbridge-macro"
        version = "1.0.85"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "3e7e2adeb6a0d4a282e581096b06e1791532b7d576dcde5ccd9382acf55db8e6"
        dependencies = [
        "proc-macro2",
        "quote",
        "syn",
        ]

        [[package]]
        name = "darling"
        version = "0.13.4"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "a01d95850c592940db9b8194bc39f4bc0e89dee5c4265e4b1807c34a9aba453c"
        dependencies = [
        "darling_core",
        "darling_macro",
        ]

        [[package]]
        name = "darling_core"
        version = "0.13.4"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "859d65a907b6852c9361e3185c862aae7fafd2887876799fa55f5f99dc40d610"
        dependencies = [
        "fnv",
        "ident_case",
        "proc-macro2",
        "quote",
        "strsim",
        "syn",
        ]

        [[package]]
        name = "darling_macro"
        version = "0.13.4"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "9c972679f83bdf9c42bd905396b6c3588a843a17f0f16dfcfa3e2c5d57441835"
        dependencies = [
        "darling_core",
        "quote",
        "syn",
        ]

        [[package]]
        name = "data-encoding"
        version = "2.3.3"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "23d8666cb01533c39dde32bcbab8e227b4ed6679b2c925eba05feabea39508fb"

        [[package]]
        name = "debug_unreachable"
        version = "0.1.1"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "9a032eac705ca39214d169f83e3d3da290af06d8d1d344d1baad2fd002dca4b3"
        dependencies = [
        "unreachable",
        ]

        [[package]]
        name = "derive-syn-parse"
        version = "0.1.5"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "e79116f119dd1dba1abf1f3405f03b9b0e79a27a3883864bfebded8a3dc768cd"
        dependencies = [
        "proc-macro2",
        "quote",
        "syn",
        ]

        [[package]]
        name = "diff"
        version = "0.1.13"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "56254986775e3233ffa9c4d7d3faaf6d36a2c09d30b20687e9f88bc8bafc16c8"

        [[package]]
        name = "digest"
        version = "0.10.6"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "8168378f4e5023e7218c89c891c0fd8ecdb5e5e4f18cb78f38cf245dd021e76f"
        dependencies = [
        "block-buffer",
        "crypto-common",
        ]

        [[package]]
        name = "dirs-next"
        version = "2.0.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "b98cf8ebf19c3d1b223e151f99a4f9f0690dca41414773390fc824184ac833e1"
        dependencies = [
        "cfg-if",
        "dirs-sys-next",
        ]

        [[package]]
        name = "dirs-sys-next"
        version = "0.1.2"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "4ebda144c4fe02d1f7ea1a7d9641b6fc6b580adcfa024ae48797ecdeb6825b4d"
        dependencies = [
        "libc",
        "redox_users",
        "winapi",
        ]

        [[package]]
        name = "dyn-clone"
        version = "1.0.10"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "c9b0705efd4599c15a38151f4721f7bc388306f61084d3bfd50bd07fbca5cb60"

        [[package]]
        name = "either"
        version = "1.8.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "90e5c1c8368803113bf0c9584fc495a58b86dc8a29edbf8fe877d21d9507e797"

        [[package]]
        name = "ena"
        version = "0.14.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "d7402b94a93c24e742487327a7cd839dc9d36fec9de9fb25b09f2dae459f36c3"
        dependencies = [
        "log",
        ]

        [[package]]
        name = "enum_kind"
        version = "0.2.1"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "78b940da354ae81ef0926c5eaa428207b8f4f091d3956c891dfbd124162bed99"
        dependencies = [
        "pmutil",
        "proc-macro2",
        "swc_macros_common",
        "syn",
        ]

        [[package]]
        name = "fast-float"
        version = "0.2.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "95765f67b4b18863968b4a1bd5bb576f732b29a4a28c7cd84c09fa3e2875f33c"

        [[package]]
        name = "fixedbitset"
        version = "0.4.2"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "0ce7134b9999ecaf8bcd65542e436736ef32ddca1b3e06094cb6ec5755203b80"

        [[package]]
        name = "fnv"
        version = "1.0.7"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "3f9eec918d3f24069decb9af1554cad7c880e2da24a9afd88aca000531ab82c1"

        [[package]]
        name = "form_urlencoded"
        version = "1.1.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "a9c384f161156f5260c24a097c56119f9be8c798586aecc13afbcbe7b7e26bf8"
        dependencies = [
        "percent-encoding",
        ]

        [[package]]
        name = "from_variant"
        version = "0.1.4"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "f0981e470d2ab9f643df3921d54f1952ea100c39fdb6a3fdc820e20d2291df6c"
        dependencies = [
        "pmutil",
        "proc-macro2",
        "swc_macros_common",
        "syn",
        ]

        [[package]]
        name = "futures"
        version = "0.3.25"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "38390104763dc37a5145a53c29c63c1290b5d316d6086ec32c293f6736051bb0"
        dependencies = [
        "futures-channel",
        "futures-core",
        "futures-executor",
        "futures-io",
        "futures-sink",
        "futures-task",
        "futures-util",
        ]

        [[package]]
        name = "futures-channel"
        version = "0.3.25"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "52ba265a92256105f45b719605a571ffe2d1f0fea3807304b522c1d778f79eed"
        dependencies = [
        "futures-core",
        "futures-sink",
        ]

        [[package]]
        name = "futures-core"
        version = "0.3.25"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "04909a7a7e4633ae6c4a9ab280aeb86da1236243a77b694a49eacd659a4bd3ac"

        [[package]]
        name = "futures-executor"
        version = "0.3.25"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "7acc85df6714c176ab5edf386123fafe217be88c0840ec11f199441134a074e2"
        dependencies = [
        "futures-core",
        "futures-task",
        "futures-util",
        ]

        [[package]]
        name = "futures-io"
        version = "0.3.25"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "00f5fb52a06bdcadeb54e8d3671f8888a39697dcb0b81b23b55174030427f4eb"

        [[package]]
        name = "futures-macro"
        version = "0.3.25"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "bdfb8ce053d86b91919aad980c220b1fb8401a9394410e1c289ed7e66b61835d"
        dependencies = [
        "proc-macro2",
        "quote",
        "syn",
        ]

        [[package]]
        name = "futures-sink"
        version = "0.3.25"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "39c15cf1a4aa79df40f1bb462fb39676d0ad9e366c2a33b590d7c66f4f81fcf9"

        [[package]]
        name = "futures-task"
        version = "0.3.25"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "2ffb393ac5d9a6eaa9d3fdf37ae2776656b706e200c8e16b1bdb227f5198e6ea"

        [[package]]
        name = "futures-util"
        version = "0.3.25"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "197676987abd2f9cadff84926f410af1c183608d36641465df73ae8211dc65d6"
        dependencies = [
        "futures-channel",
        "futures-core",
        "futures-io",
        "futures-macro",
        "futures-sink",
        "futures-task",
        "memchr",
        "pin-project-lite",
        "pin-utils",
        "slab",
        ]

        [[package]]
        name = "generic-array"
        version = "0.14.6"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "bff49e947297f3312447abdca79f45f4738097cc82b06e72054d2223f601f1b9"
        dependencies = [
        "typenum",
        "version_check",
        ]

        [[package]]
        name = "getrandom"
        version = "0.2.8"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "c05aeb6a22b8f62540c194aac980f2115af067bfe15a0734d7277a768d396b31"
        dependencies = [
        "cfg-if",
        "libc",
        "wasi",
        ]

        [[package]]
        name = "hashbrown"
        version = "0.12.3"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "8a9ee70c43aaf417c914396645a0fa852624801b24ebb7ae78fe8272889ac888"

        [[package]]
        name = "hermit-abi"
        version = "0.1.19"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "62b467343b94ba476dcb2500d242dadbb39557df889310ac77c5d99100aaac33"
        dependencies = [
        "libc",
        ]

        [[package]]
        name = "hex"
        version = "0.4.3"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "7f24254aa9a54b5c858eaee2f5bccdb46aaf0e486a595ed5fd8f86ba55232a70"

        [[package]]
        name = "iana-time-zone"
        version = "0.1.53"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "64c122667b287044802d6ce17ee2ddf13207ed924c712de9a66a5814d5b64765"
        dependencies = [
        "android_system_properties",
        "core-foundation-sys",
        "iana-time-zone-haiku",
        "js-sys",
        "wasm-bindgen",
        "winapi",
        ]

        [[package]]
        name = "iana-time-zone-haiku"
        version = "0.1.1"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "0703ae284fc167426161c2e3f1da3ea71d94b21bedbcc9494e92b28e334e3dca"
        dependencies = [
        "cxx",
        "cxx-build",
        ]

        [[package]]
        name = "ic-cdk"
        version = "0.6.8"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "e2693ba66f3d54284643713ca2be0b23f91a02cb3ab793a22ffd75f95593305e"
        dependencies = [
        "candid",
        "cfg-if",
        "futures",
        "ic-cdk-macros",
        "ic0",
        "serde",
        "serde_bytes",
        "slotmap",
        ]

        [[package]]
        name = "ic-cdk-macros"
        version = "0.6.8"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "cb423dab7c5bf19d4abccabd2ffe35e09b9dde611d478ea3afe0347b50fa727f"
        dependencies = [
        "candid",
        "proc-macro2",
        "quote",
        "serde",
        "serde_tokenstream",
        "syn",
        ]

        [[package]]
        name = "ic0"
        version = "0.18.7"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "e17ec1438d667907ee275368801390f45ba0b4f6e6c2a45221e5d01199187f4f"

        [[package]]
        name = "ident_case"
        version = "1.0.1"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "b9e0384b61958566e926dc50660321d12159025e767c18e043daf26b70104c39"

        [[package]]
        name = "idna"
        version = "0.3.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "e14ddfc70884202db2244c223200c204c2bda1bc6e0998d11b5e024d657209e6"
        dependencies = [
        "unicode-bidi",
        "unicode-normalization",
        ]

        [[package]]
        name = "indexmap"
        version = "1.9.2"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "1885e79c1fc4b10f0e172c475f458b7f7b93061064d98c3293e98c5ba0c8b399"
        dependencies = [
        "autocfg",
        "hashbrown",
        ]

        [[package]]
        name = "is-macro"
        version = "0.2.1"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "1c068d4c6b922cd6284c609cfa6dec0e41615c9c5a1a4ba729a970d8daba05fb"
        dependencies = [
        "Inflector",
        "pmutil",
        "proc-macro2",
        "quote",
        "syn",
        ]

        [[package]]
        name = "itertools"
        version = "0.10.5"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "b0fd2260e829bddf4cb6ea802289de2f86d6a7a690192fbe91b3f46e0f2c8473"
        dependencies = [
        "either",
        ]

        [[package]]
        name = "itoa"
        version = "1.0.5"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "fad582f4b9e86b6caa621cabeb0963332d92eea04729ab12892c2533951e6440"

        [[package]]
        name = "js-sys"
        version = "0.3.60"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "49409df3e3bf0856b916e2ceaca09ee28e6871cf7d9ce97a692cacfdb2a25a47"
        dependencies = [
        "wasm-bindgen",
        ]

        [[package]]
        name = "lalrpop"
        version = "0.19.8"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "b30455341b0e18f276fa64540aff54deafb54c589de6aca68659c63dd2d5d823"
        dependencies = [
        "ascii-canvas",
        "atty",
        "bit-set",
        "diff",
        "ena",
        "itertools",
        "lalrpop-util",
        "petgraph",
        "pico-args",
        "regex",
        "regex-syntax",
        "string_cache",
        "term",
        "tiny-keccak",
        "unicode-xid",
        ]

        [[package]]
        name = "lalrpop-util"
        version = "0.19.8"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "bcf796c978e9b4d983414f4caedc9273aa33ee214c5b887bd55fde84c85d2dc4"
        dependencies = [
        "regex",
        ]

        [[package]]
        name = "lazy_static"
        version = "1.4.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "e2abad23fbc42b3700f2f279844dc832adb2b2eb069b2df918f455c4e18cc646"

        [[package]]
        name = "leb128"
        version = "0.2.5"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "884e2677b40cc8c339eaefcb701c32ef1fd2493d71118dc0ca4b6a736c93bd67"

        [[package]]
        name = "lexical"
        version = "6.1.1"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "c7aefb36fd43fef7003334742cbf77b243fcd36418a1d1bdd480d613a67968f6"
        dependencies = [
        "lexical-core",
        ]

        [[package]]
        name = "lexical-core"
        version = "0.8.5"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "2cde5de06e8d4c2faabc400238f9ae1c74d5412d03a7bd067645ccbc47070e46"
        dependencies = [
        "lexical-parse-float",
        "lexical-parse-integer",
        "lexical-util",
        "lexical-write-float",
        "lexical-write-integer",
        ]

        [[package]]
        name = "lexical-parse-float"
        version = "0.8.5"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "683b3a5ebd0130b8fb52ba0bdc718cc56815b6a097e28ae5a6997d0ad17dc05f"
        dependencies = [
        "lexical-parse-integer",
        "lexical-util",
        "static_assertions",
        ]

        [[package]]
        name = "lexical-parse-integer"
        version = "0.8.6"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "6d0994485ed0c312f6d965766754ea177d07f9c00c9b82a5ee62ed5b47945ee9"
        dependencies = [
        "lexical-util",
        "static_assertions",
        ]

        [[package]]
        name = "lexical-util"
        version = "0.8.5"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "5255b9ff16ff898710eb9eb63cb39248ea8a5bb036bea8085b1a767ff6c4e3fc"
        dependencies = [
        "static_assertions",
        ]

        [[package]]
        name = "lexical-write-float"
        version = "0.8.5"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "accabaa1c4581f05a3923d1b4cfd124c329352288b7b9da09e766b0668116862"
        dependencies = [
        "lexical-util",
        "lexical-write-integer",
        "static_assertions",
        ]

        [[package]]
        name = "lexical-write-integer"
        version = "0.8.5"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "e1b6f3d1f4422866b68192d62f77bc5c700bee84f3069f2469d7bc8c77852446"
        dependencies = [
        "lexical-util",
        "static_assertions",
        ]

        [[package]]
        name = "libc"
        version = "0.2.138"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "db6d7e329c562c5dfab7a46a2afabc8b987ab9a4834c9d1ca04dc54c1546cef8"

        [[package]]
        name = "link-cplusplus"
        version = "1.0.8"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "ecd207c9c713c34f95a097a5b029ac2ce6010530c7b49d7fea24d977dede04f5"
        dependencies = [
        "cc",
        ]

        [[package]]
        name = "lock_api"
        version = "0.4.9"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "435011366fe56583b16cf956f9df0095b405b82d76425bc8981c0e22e60ec4df"
        dependencies = [
        "autocfg",
        "scopeguard",
        ]

        [[package]]
        name = "log"
        version = "0.4.17"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "abb12e687cfb44aa40f41fc3978ef76448f9b6038cad6aef4259d3c095a2382e"
        dependencies = [
        "cfg-if",
        ]

        [[package]]
        name = "logos"
        version = "0.12.1"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "bf8b031682c67a8e3d5446840f9573eb7fe26efe7ec8d195c9ac4c0647c502f1"
        dependencies = [
        "logos-derive",
        ]

        [[package]]
        name = "logos-derive"
        version = "0.12.1"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "a1d849148dbaf9661a6151d1ca82b13bb4c4c128146a88d05253b38d4e2f496c"
        dependencies = [
        "beef",
        "fnv",
        "proc-macro2",
        "quote",
        "regex-syntax",
        "syn",
        ]

        [[package]]
        name = "memchr"
        version = "2.5.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "2dffe52ecf27772e601905b7522cb4ef790d2cc203488bbd0e2fe85fcb74566d"

        [[package]]
        name = "new_debug_unreachable"
        version = "1.0.4"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "e4a24736216ec316047a1fc4252e27dabb04218aa4a3f37c6e7ddbf1f9782b54"

        [[package]]
        name = "num-bigint"
        version = "0.4.3"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "f93ab6289c7b344a8a9f60f88d80aa20032336fe78da341afc91c8a2341fc75f"
        dependencies = [
        "autocfg",
        "num-integer",
        "num-traits",
        "serde",
        ]

        [[package]]
        name = "num-integer"
        version = "0.1.45"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "225d3389fb3509a24c93f5c29eb6bde2586b98d9f016636dff58d7c6f7569cd9"
        dependencies = [
        "autocfg",
        "num-traits",
        ]

        [[package]]
        name = "num-traits"
        version = "0.2.15"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "578ede34cf02f8924ab9447f50c28075b4d3e5b269972345e7e0372b38c6cdcd"
        dependencies = [
        "autocfg",
        ]

        [[package]]
        name = "num_enum"
        version = "0.5.7"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "cf5395665662ef45796a4ff5486c5d41d29e0c09640af4c5f17fd94ee2c119c9"
        dependencies = [
        "num_enum_derive",
        ]

        [[package]]
        name = "num_enum_derive"
        version = "0.5.7"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "3b0498641e53dd6ac1a4f22547548caa6864cc4933784319cd1775271c5a46ce"
        dependencies = [
        "proc-macro-crate",
        "proc-macro2",
        "quote",
        "syn",
        ]

        [[package]]
        name = "once_cell"
        version = "1.16.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "86f0b0d4bf799edbc74508c1e8bf170ff5f41238e5f8225603ca7caaae2b7860"

        [[package]]
        name = "parking_lot"
        version = "0.12.1"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "3742b2c103b9f06bc9fff0a37ff4912935851bee6d36f3c02bcc755bcfec228f"
        dependencies = [
        "lock_api",
        "parking_lot_core",
        ]

        [[package]]
        name = "parking_lot_core"
        version = "0.9.5"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "7ff9f3fef3968a3ec5945535ed654cb38ff72d7495a25619e2247fb15a2ed9ba"
        dependencies = [
        "cfg-if",
        "libc",
        "redox_syscall",
        "smallvec",
        "windows-sys",
        ]

        [[package]]
        name = "paste"
        version = "1.0.11"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "d01a5bd0424d00070b0098dd17ebca6f961a959dead1dbcbbbc1d1cd8d3deeba"

        [[package]]
        name = "percent-encoding"
        version = "2.2.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "478c572c3d73181ff3c2539045f6eb99e5491218eae919370993b890cdbdd98e"

        [[package]]
        name = "petgraph"
        version = "0.6.2"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "e6d5014253a1331579ce62aa67443b4a658c5e7dd03d4bc6d302b94474888143"
        dependencies = [
        "fixedbitset",
        "indexmap",
        ]

        [[package]]
        name = "phf"
        version = "0.11.1"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "928c6535de93548188ef63bb7c4036bd415cd8f36ad25af44b9789b2ee72a48c"
        dependencies = [
        "phf_macros",
        "phf_shared 0.11.1",
        ]

        [[package]]
        name = "phf_generator"
        version = "0.10.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "5d5285893bb5eb82e6aaf5d59ee909a06a16737a8970984dd7746ba9283498d6"
        dependencies = [
        "phf_shared 0.10.0",
        "rand",
        ]

        [[package]]
        name = "phf_generator"
        version = "0.11.1"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "b1181c94580fa345f50f19d738aaa39c0ed30a600d95cb2d3e23f94266f14fbf"
        dependencies = [
        "phf_shared 0.11.1",
        "rand",
        ]

        [[package]]
        name = "phf_macros"
        version = "0.11.1"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "92aacdc5f16768709a569e913f7451034034178b05bdc8acda226659a3dccc66"
        dependencies = [
        "phf_generator 0.11.1",
        "phf_shared 0.11.1",
        "proc-macro2",
        "quote",
        "syn",
        ]

        [[package]]
        name = "phf_shared"
        version = "0.10.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "b6796ad771acdc0123d2a88dc428b5e38ef24456743ddb1744ed628f9815c096"
        dependencies = [
        "siphasher",
        ]

        [[package]]
        name = "phf_shared"
        version = "0.11.1"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "e1fb5f6f826b772a8d4c0394209441e7d37cbbb967ae9c7e0e8134365c9ee676"
        dependencies = [
        "siphasher",
        ]

        [[package]]
        name = "pico-args"
        version = "0.4.2"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "db8bcd96cb740d03149cbad5518db9fd87126a10ab519c011893b1754134c468"

        [[package]]
        name = "pin-project-lite"
        version = "0.2.9"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "e0a7ae3ac2f1173085d398531c705756c94a4c56843785df85a60c1a0afac116"

        [[package]]
        name = "pin-utils"
        version = "0.1.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "8b870d8c151b6f2fb93e84a13146138f05d02ed11c7e7c54f8826aaaf7c9f184"

        [[package]]
        name = "pmutil"
        version = "0.5.3"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "3894e5d549cccbe44afecf72922f277f603cd4bb0219c8342631ef18fffbe004"
        dependencies = [
        "proc-macro2",
        "quote",
        "syn",
        ]

        [[package]]
        name = "ppv-lite86"
        version = "0.2.17"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "5b40af805b3121feab8a3c29f04d8ad262fa8e0561883e7653e024ae4479e6de"

        [[package]]
        name = "precomputed-hash"
        version = "0.1.1"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "925383efa346730478fb4838dbe9137d2a47675ad789c546d150a6e1dd4ab31c"

        [[package]]
        name = "pretty"
        version = "0.10.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "ad9940b913ee56ddd94aec2d3cd179dd47068236f42a1a6415ccf9d880ce2a61"
        dependencies = [
        "arrayvec",
        "typed-arena",
        ]

        [[package]]
        name = "proc-macro-crate"
        version = "1.2.1"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "eda0fc3b0fb7c975631757e14d9049da17374063edb6ebbcbc54d880d4fe94e9"
        dependencies = [
        "once_cell",
        "thiserror",
        "toml",
        ]

        [[package]]
        name = "proc-macro2"
        version = "1.0.49"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "57a8eca9f9c4ffde41714334dee777596264c7825420f521abc92b5b5deb63a5"
        dependencies = [
        "unicode-ident",
        ]

        [[package]]
        name = "quote"
        version = "1.0.23"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "8856d8364d252a14d474036ea1358d63c9e6965c8e5c1885c18f73d70bff9c7b"
        dependencies = [
        "proc-macro2",
        ]

        [[package]]
        name = "rand"
        version = "0.8.5"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "34af8d1a0e25924bc5b7c43c079c942339d8f0a8b57c39049bef581b46327404"
        dependencies = [
        "libc",
        "rand_chacha",
        "rand_core",
        ]

        [[package]]
        name = "rand_chacha"
        version = "0.3.1"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "e6c10a63a0fa32252be49d21e7709d4d4baf8d231c2dbce1eaa8141b9b127d88"
        dependencies = [
        "ppv-lite86",
        "rand_core",
        ]

        [[package]]
        name = "rand_core"
        version = "0.6.4"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "ec0be4795e2f6a28069bec0b5ff3e2ac9bafc99e6a9a7dc3547996c5c816922c"
        dependencies = [
        "getrandom",
        ]

        [[package]]
        name = "redox_syscall"
        version = "0.2.16"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "fb5a58c1855b4b6819d59012155603f0b22ad30cad752600aadfcb695265519a"
        dependencies = [
        "bitflags",
        ]

        [[package]]
        name = "redox_users"
        version = "0.4.3"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "b033d837a7cf162d7993aded9304e30a83213c648b6e389db233191f891e5c2b"
        dependencies = [
        "getrandom",
        "redox_syscall",
        "thiserror",
        ]

        [[package]]
        name = "regex"
        version = "1.7.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "e076559ef8e241f2ae3479e36f97bd5741c0330689e217ad51ce2c76808b868a"
        dependencies = [
        "aho-corasick",
        "memchr",
        "regex-syntax",
        ]

        [[package]]
        name = "regex-syntax"
        version = "0.6.28"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "456c603be3e8d448b072f410900c09faf164fbce2d480456f50eea6e25f9c848"

        [[package]]
        name = "regress"
        version = "0.4.1"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "0a92ff21fe8026ce3f2627faaf43606f0b67b014dbc9ccf027181a804f75d92e"
        dependencies = [
        "memchr",
        ]

        [[package]]
        name = "rustc-hash"
        version = "1.1.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "08d43f7aa6b08d49f382cde6a7982047c3426db949b1424bc4b7ec9ae12c6ce2"

        [[package]]
        name = "rustversion"
        version = "1.0.11"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "5583e89e108996506031660fe09baa5011b9dd0341b89029313006d1fb508d70"

        [[package]]
        name = "ryu"
        version = "1.0.12"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "7b4b9743ed687d4b4bcedf9ff5eaa7398495ae14e61cba0a295704edbc7decde"

        [[package]]
        name = "ryu-js"
        version = "0.2.2"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "6518fc26bced4d53678a22d6e423e9d8716377def84545fe328236e3af070e7f"

        [[package]]
        name = "scoped-tls"
        version = "1.0.1"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "e1cf6437eb19a8f4a6cc0f7dca544973b0b78843adbfeb3683d1a94a0024a294"

        [[package]]
        name = "scopeguard"
        version = "1.1.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "d29ab0c6d3fc0ee92fe66e2d99f700eab17a8d57d1c1d3b748380fb20baa78cd"

        [[package]]
        name = "scratch"
        version = "1.0.3"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "ddccb15bcce173023b3fedd9436f882a0739b8dfb45e4f6b6002bee5929f61b2"

        [[package]]
        name = "serde"
        version = "1.0.151"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "97fed41fc1a24994d044e6db6935e69511a1153b52c15eb42493b26fa87feba0"
        dependencies = [
        "serde_derive",
        ]

        [[package]]
        name = "serde_bytes"
        version = "0.11.8"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "718dc5fff5b36f99093fc49b280cfc96ce6fc824317783bff5a1fed0c7a64819"
        dependencies = [
        "serde",
        ]

        [[package]]
        name = "serde_derive"
        version = "1.0.151"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "255abe9a125a985c05190d687b320c12f9b1f0b99445e608c21ba0782c719ad8"
        dependencies = [
        "proc-macro2",
        "quote",
        "syn",
        ]

        [[package]]
        name = "serde_json"
        version = "1.0.91"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "877c235533714907a8c2464236f5c4b2a17262ef1bd71f38f35ea592c8da6883"
        dependencies = [
        "itoa",
        "ryu",
        "serde",
        ]

        [[package]]
        name = "serde_tokenstream"
        version = "0.1.5"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "2794f0ba0179a8ca422c30d9975d86faf8306be0164bfc3b0b1ca4f060ac639d"
        dependencies = [
        "proc-macro2",
        "serde",
        "syn",
        ]

        [[package]]
        name = "sha2"
        version = "0.10.6"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "82e6b795fe2e3b1e845bafcb27aa35405c4d47cdfc92af5fc8d3002f76cebdc0"
        dependencies = [
        "cfg-if",
        "cpufeatures",
        "digest",
        ]

        [[package]]
        name = "siphasher"
        version = "0.3.10"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "7bd3e3206899af3f8b12af284fafc038cc1dc2b41d1b89dd17297221c5d225de"

        [[package]]
        name = "slab"
        version = "0.4.7"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "4614a76b2a8be0058caa9dbbaf66d988527d86d003c11a94fbd335d7661edcef"
        dependencies = [
        "autocfg",
        ]

        [[package]]
        name = "slotmap"
        version = "1.0.6"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "e1e08e261d0e8f5c43123b7adf3e4ca1690d655377ac93a03b2c9d3e98de1342"
        dependencies = [
        "version_check",
        ]

        [[package]]
        name = "smallvec"
        version = "1.10.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "a507befe795404456341dfab10cef66ead4c041f62b8b11bbb92bffe5d0953e0"

        [[package]]
        name = "sptr"
        version = "0.3.2"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "3b9b39299b249ad65f3b7e96443bad61c02ca5cd3589f46cb6d610a0fd6c0d6a"

        [[package]]
        name = "stable_deref_trait"
        version = "1.2.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "a8f112729512f8e442d81f95a8a7ddf2b7c6b8a1a6f509a95864142b30cab2d3"

        [[package]]
        name = "static_assertions"
        version = "1.1.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "a2eb9349b6444b326872e140eb1cf5e7c522154d69e7a0ffb0fb81c06b37543f"

        [[package]]
        name = "string_cache"
        version = "0.8.4"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "213494b7a2b503146286049378ce02b482200519accc31872ee8be91fa820a08"
        dependencies = [
        "new_debug_unreachable",
        "once_cell",
        "parking_lot",
        "phf_shared 0.10.0",
        "precomputed-hash",
        "serde",
        ]

        [[package]]
        name = "string_cache_codegen"
        version = "0.5.2"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "6bb30289b722be4ff74a408c3cc27edeaad656e06cb1fe8fa9231fa59c728988"
        dependencies = [
        "phf_generator 0.10.0",
        "phf_shared 0.10.0",
        "proc-macro2",
        "quote",
        ]

        [[package]]
        name = "string_enum"
        version = "0.3.2"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "994453cd270ad0265796eb24abf5540091ed03e681c5f3c12bc33e4db33253e1"
        dependencies = [
        "pmutil",
        "proc-macro2",
        "quote",
        "swc_macros_common",
        "syn",
        ]

        [[package]]
        name = "strsim"
        version = "0.10.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "73473c0e59e6d5812c5dfe2a064a6444949f089e20eec9a2e5506596494e4623"

        [[package]]
        name = "swc_atoms"
        version = "0.4.31"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "01f007debbe495e480cc36d06c9192510f059bc0dea8b7209ce4fa9c107c52c7"
        dependencies = [
        "once_cell",
        "rustc-hash",
        "serde",
        "string_cache",
        "string_cache_codegen",
        "triomphe",
        ]

        [[package]]
        name = "swc_common"
        version = "0.27.16"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "49b0b6107e44797d0549bdb5b47a97682c3b914140269c01d2acdb16a1b885f6"
        dependencies = [
        "ahash",
        "ast_node",
        "better_scoped_tls",
        "cfg-if",
        "debug_unreachable",
        "either",
        "from_variant",
        "num-bigint",
        "once_cell",
        "rustc-hash",
        "serde",
        "siphasher",
        "string_cache",
        "swc_atoms",
        "swc_eq_ignore_macros",
        "swc_visit",
        "tracing",
        "unicode-width",
        "url",
        ]

        [[package]]
        name = "swc_ecma_ast"
        version = "0.90.20"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "f712949db06518bec7b7e050aa3bcde749a74fbf79f4f520ab179d0445b63593"
        dependencies = [
        "bitflags",
        "is-macro",
        "num-bigint",
        "scoped-tls",
        "serde",
        "string_enum",
        "swc_atoms",
        "swc_common",
        "unicode-id",
        ]

        [[package]]
        name = "swc_ecma_parser"
        version = "0.117.7"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "d88ffca99514bc8bfa8bf4f2d74fb673caa844e521b55035b8cfd10472b801d4"
        dependencies = [
        "either",
        "enum_kind",
        "lexical",
        "num-bigint",
        "serde",
        "smallvec",
        "swc_atoms",
        "swc_common",
        "swc_ecma_ast",
        "tracing",
        "typed-arena",
        ]

        [[package]]
        name = "swc_eq_ignore_macros"
        version = "0.1.1"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "0c20468634668c2bbab581947bb8c75c97158d5a6959f4ba33df20983b20b4f6"
        dependencies = [
        "pmutil",
        "proc-macro2",
        "quote",
        "syn",
        ]

        [[package]]
        name = "swc_macros_common"
        version = "0.3.6"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "a4be988307882648d9bc7c71a6a73322b7520ef0211e920489a98f8391d8caa2"
        dependencies = [
        "pmutil",
        "proc-macro2",
        "quote",
        "syn",
        ]

        [[package]]
        name = "swc_visit"
        version = "0.5.3"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "82f2bcb7223e185c4c7cbf5e0c1207dec6d2bfd5e72e3fb7b3e8d179747e9130"
        dependencies = [
        "either",
        "swc_visit_macros",
        ]

        [[package]]
        name = "swc_visit_macros"
        version = "0.5.4"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "8fb1f3561674d84947694d41fb6d5737d19539222779baeac1b3a071a2b29428"
        dependencies = [
        "Inflector",
        "pmutil",
        "proc-macro2",
        "quote",
        "swc_macros_common",
        "syn",
        ]

        [[package]]
        name = "syn"
        version = "1.0.107"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "1f4064b5b16e03ae50984a5a8ed5d4f8803e6bc1fd170a3cda91a1be4b18e3f5"
        dependencies = [
        "proc-macro2",
        "quote",
        "unicode-ident",
        ]

        [[package]]
        name = "synstructure"
        version = "0.12.6"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "f36bdaa60a83aca3921b5259d5400cbf5e90fc51931376a9bd4a0eb79aa7210f"
        dependencies = [
        "proc-macro2",
        "quote",
        "syn",
        "unicode-xid",
        ]

        [[package]]
        name = "tap"
        version = "1.0.1"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "55937e1799185b12863d447f42597ed69d9928686b8d88a1df17376a097d8369"

        [[package]]
        name = "term"
        version = "0.7.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "c59df8ac95d96ff9bede18eb7300b0fda5e5d8d90960e76f8e14ae765eedbf1f"
        dependencies = [
        "dirs-next",
        "rustversion",
        "winapi",
        ]

        [[package]]
        name = "termcolor"
        version = "1.1.3"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "bab24d30b911b2376f3a13cc2cd443142f0c81dda04c118693e35b3835757755"
        dependencies = [
        "winapi-util",
        ]

        [[package]]
        name = "thiserror"
        version = "1.0.38"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "6a9cd18aa97d5c45c6603caea1da6628790b37f7a34b6ca89522331c5180fed0"
        dependencies = [
        "thiserror-impl",
        ]

        [[package]]
        name = "thiserror-impl"
        version = "1.0.38"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "1fb327af4685e4d03fa8cbcf1716380da910eeb2bb8be417e7f9fd3fb164f36f"
        dependencies = [
        "proc-macro2",
        "quote",
        "syn",
        ]

        [[package]]
        name = "tiny-keccak"
        version = "2.0.2"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "2c9d3793400a45f954c52e73d068316d76b6f4e36977e3fcebb13a2721e80237"
        dependencies = [
        "crunchy",
        ]

        [[package]]
        name = "tinyvec"
        version = "1.6.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "87cc5ceb3875bb20c2890005a4e226a4651264a5c75edb2421b52861a0a0cb50"
        dependencies = [
        "tinyvec_macros",
        ]

        [[package]]
        name = "tinyvec_macros"
        version = "0.1.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "cda74da7e1a664f795bb1f8a87ec406fb89a02522cf6e50620d016add6dbbf5c"

        [[package]]
        name = "toml"
        version = "0.5.10"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "1333c76748e868a4d9d1017b5ab53171dfd095f70c712fdb4653a406547f598f"
        dependencies = [
        "serde",
        ]

        [[package]]
        name = "tracing"
        version = "0.1.37"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "8ce8c33a8d48bd45d624a6e523445fd21ec13d3653cd51f681abf67418f54eb8"
        dependencies = [
        "cfg-if",
        "pin-project-lite",
        "tracing-attributes",
        "tracing-core",
        ]

        [[package]]
        name = "tracing-attributes"
        version = "0.1.23"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "4017f8f45139870ca7e672686113917c71c7a6e02d4924eda67186083c03081a"
        dependencies = [
        "proc-macro2",
        "quote",
        "syn",
        ]

        [[package]]
        name = "tracing-core"
        version = "0.1.30"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "24eb03ba0eab1fd845050058ce5e616558e8f8d8fca633e6b163fe25c797213a"
        dependencies = [
        "once_cell",
        ]

        [[package]]
        name = "triomphe"
        version = "0.1.8"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "f1ee9bd9239c339d714d657fac840c6d2a4f9c45f4f9ec7b0975113458be78db"
        dependencies = [
        "serde",
        "stable_deref_trait",
        ]

        [[package]]
        name = "typed-arena"
        version = "2.0.1"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "0685c84d5d54d1c26f7d3eb96cd41550adb97baed141a761cf335d3d33bcd0ae"

        [[package]]
        name = "typenum"
        version = "1.16.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "497961ef93d974e23eb6f433eb5fe1b7930b659f06d12dec6fc44a8f554c0bba"

        [[package]]
        name = "unicode-bidi"
        version = "0.3.8"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "099b7128301d285f79ddd55b9a83d5e6b9e97c92e0ea0daebee7263e932de992"

        [[package]]
        name = "unicode-general-category"
        version = "0.6.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "2281c8c1d221438e373249e065ca4989c4c36952c211ff21a0ee91c44a3869e7"

        [[package]]
        name = "unicode-id"
        version = "0.3.3"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "d70b6494226b36008c8366c288d77190b3fad2eb4c10533139c1c1f461127f1a"

        [[package]]
        name = "unicode-ident"
        version = "1.0.6"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "84a22b9f218b40614adcb3f4ff08b703773ad44fa9423e4e0d346d5db86e4ebc"

        [[package]]
        name = "unicode-normalization"
        version = "0.1.22"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "5c5713f0fc4b5db668a2ac63cdb7bb4469d8c9fed047b1d0292cc7b0ce2ba921"
        dependencies = [
        "tinyvec",
        ]

        [[package]]
        name = "unicode-width"
        version = "0.1.10"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "c0edd1e5b14653f783770bce4a4dabb4a5108a5370a5f5d8cfe8710c361f6c8b"

        [[package]]
        name = "unicode-xid"
        version = "0.2.4"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "f962df74c8c05a667b5ee8bcf162993134c104e96440b663c8daa176dc772d8c"

        [[package]]
        name = "unreachable"
        version = "0.1.1"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "1f2ae5ddb18e1c92664717616dd9549dde73f539f01bd7b77c2edb2446bdff91"
        dependencies = [
        "void",
        ]

        [[package]]
        name = "url"
        version = "2.3.1"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "0d68c799ae75762b8c3fe375feb6600ef5602c883c5d21eb51c09f22b83c4643"
        dependencies = [
        "form_urlencoded",
        "idna",
        "percent-encoding",
        ]

        [[package]]
        name = "uuid"
        version = "1.2.2"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "422ee0de9031b5b948b97a8fc04e3aa35230001a722ddd27943e0be31564ce4c"
        dependencies = [
        "getrandom",
        ]

        [[package]]
        name = "version_check"
        version = "0.9.4"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "49874b5167b65d7193b8aba1567f5c7d93d001cafc34600cee003eda787e483f"

        [[package]]
        name = "void"
        version = "1.0.2"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "6a02e4885ed3bc0f2de90ea6dd45ebcbb66dacffe03547fadbb0eeae2770887d"

        [[package]]
        name = "wasi"
        version = "0.11.0+wasi-snapshot-preview1"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "9c8d87e72b64a3b4db28d11ce29237c246188f4f51057d65a7eab63b7987e423"

        [[package]]
        name = "wasm-bindgen"
        version = "0.2.83"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "eaf9f5aceeec8be17c128b2e93e031fb8a4d469bb9c4ae2d7dc1888b26887268"
        dependencies = [
        "cfg-if",
        "wasm-bindgen-macro",
        ]

        [[package]]
        name = "wasm-bindgen-backend"
        version = "0.2.83"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "4c8ffb332579b0557b52d268b91feab8df3615f265d5270fec2a8c95b17c1142"
        dependencies = [
        "bumpalo",
        "log",
        "once_cell",
        "proc-macro2",
        "quote",
        "syn",
        "wasm-bindgen-shared",
        ]

        [[package]]
        name = "wasm-bindgen-macro"
        version = "0.2.83"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "052be0f94026e6cbc75cdefc9bae13fd6052cdcaf532fa6c45e7ae33a1e6c810"
        dependencies = [
        "quote",
        "wasm-bindgen-macro-support",
        ]

        [[package]]
        name = "wasm-bindgen-macro-support"
        version = "0.2.83"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "07bc0c051dc5f23e307b13285f9d75df86bfdf816c5721e573dec1f9b8aa193c"
        dependencies = [
        "proc-macro2",
        "quote",
        "syn",
        "wasm-bindgen-backend",
        "wasm-bindgen-shared",
        ]

        [[package]]
        name = "wasm-bindgen-shared"
        version = "0.2.83"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "1c38c045535d93ec4f0b4defec448e4291638ee608530863b1e2ba115d4fff7f"

        [[package]]
        name = "winapi"
        version = "0.3.9"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "5c839a674fcd7a98952e593242ea400abe93992746761e38641405d28b00f419"
        dependencies = [
        "winapi-i686-pc-windows-gnu",
        "winapi-x86_64-pc-windows-gnu",
        ]

        [[package]]
        name = "winapi-i686-pc-windows-gnu"
        version = "0.4.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "ac3b87c63620426dd9b991e5ce0329eff545bccbbb34f3be09ff6fb6ab51b7b6"

        [[package]]
        name = "winapi-util"
        version = "0.1.5"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "70ec6ce85bb158151cae5e5c87f95a8e97d2c0c4b001223f33a334e3ce5de178"
        dependencies = [
        "winapi",
        ]

        [[package]]
        name = "winapi-x86_64-pc-windows-gnu"
        version = "0.4.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "712e227841d057c1ee1cd2fb22fa7e5a5461ae8e48fa2ca79ec42cfc1931183f"

        [[package]]
        name = "windows-sys"
        version = "0.42.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "5a3e1820f08b8513f676f7ab6c1f99ff312fb97b553d30ff4dd86f9f15728aa7"
        dependencies = [
        "windows_aarch64_gnullvm",
        "windows_aarch64_msvc",
        "windows_i686_gnu",
        "windows_i686_msvc",
        "windows_x86_64_gnu",
        "windows_x86_64_gnullvm",
        "windows_x86_64_msvc",
        ]

        [[package]]
        name = "windows_aarch64_gnullvm"
        version = "0.42.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "41d2aa71f6f0cbe00ae5167d90ef3cfe66527d6f613ca78ac8024c3ccab9a19e"

        [[package]]
        name = "windows_aarch64_msvc"
        version = "0.42.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "dd0f252f5a35cac83d6311b2e795981f5ee6e67eb1f9a7f64eb4500fbc4dcdb4"

        [[package]]
        name = "windows_i686_gnu"
        version = "0.42.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "fbeae19f6716841636c28d695375df17562ca208b2b7d0dc47635a50ae6c5de7"

        [[package]]
        name = "windows_i686_msvc"
        version = "0.42.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "84c12f65daa39dd2babe6e442988fc329d6243fdce47d7d2d155b8d874862246"

        [[package]]
        name = "windows_x86_64_gnu"
        version = "0.42.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "bf7b1b21b5362cbc318f686150e5bcea75ecedc74dd157d874d754a2ca44b0ed"

        [[package]]
        name = "windows_x86_64_gnullvm"
        version = "0.42.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "09d525d2ba30eeb3297665bd434a54297e4170c7f1a44cad4ef58095b4cd2028"

        [[package]]
        name = "windows_x86_64_msvc"
        version = "0.42.0"
        source = "registry+https://github.com/rust-lang/crates.io-index"
        checksum = "f40009d85759725a34da6d89a94e63d7bdc50a862acf0dbc7c8e488f1edcb6f5"
    `;
}
